/**********************************************************************

	--- Qt Architect generated file ---

	File: GfScaleWin.cpp
	Last generated: Fri Jul 2 15:20:56 1999

 *********************************************************************/

#include "GfScaleWin.h"
#include "../gfutil.h"
#include <string.h>

#define Inherited GfScaleWinData

GfScaleWin::GfScaleWin
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
	setCaption( "ReScale" );
	
	init();
}

GfScaleWin::GfScaleWin
(
	GfFile *gff
)
	:
	Inherited( NULL, NULL )
{
	setCaption( "ReScale" );
	
	gfscale = gff->scale();
	
	gffile = gff;
	
	init();
}

void GfScaleWin::init()
{
	dvalid = new QDoubleValidator(1.e36,-1.e36,6,this);
/* needs a better validator
	
	xmax_lineedit->setValidator(dvalid);
	xmin_lineedit->setValidator(dvalid);
	ymax_lineedit->setValidator(dvalid);
	ymin_lineedit->setValidator(dvalid);
	xstep_lineedit->setValidator(dvalid);
	ystep_lineedit->setValidator(dvalid);
*/	
	setValues();
	setVisibles();
	
	if(gffile->numPoints() == 0)
	{
		auto_button->setEnabled(FALSE);
	}
}


GfScaleWin::~GfScaleWin()
{
	delete dvalid;
}

void GfScaleWin::setValues()
{
char text[50],*label;

	sprintf(text,"%g",gfscale.xMax());
	xmax_lineedit->setText(text);
	sprintf(text,"%g",gfscale.xMin());
	xmin_lineedit->setText(text);
	
	sprintf(text,"%g",gfscale.yMax());
	ymax_lineedit->setText(text);
	sprintf(text,"%g",gfscale.yMin());
	ymin_lineedit->setText(text);

	sprintf(text,"%g",gfscale.xTicksStep());
	xstep_lineedit->setText(text);

	sprintf(text,"%g",gfscale.yTicksStep());
	ystep_lineedit->setText(text);

	if(gfscale.xLogScale() == GF_YES)
	{
		xlogscale_checkbox->setChecked(TRUE);
	}
	else
	{
		xlogscale_checkbox->setChecked(FALSE);
	}
	
	if(gfscale.xMax() <= 0.0 || gfscale.xMin() <= 0.0)
	{
		xlogscale_checkbox->setEnabled(FALSE);
	}
	else
	{
		xlogscale_checkbox->setEnabled(TRUE);
	}

	if(gfscale.yLogScale() == GF_YES)
	{
		ylogscale_checkbox->setChecked(TRUE);
	}
	else
	{
		ylogscale_checkbox->setChecked(FALSE);
	}
	
	if(gfscale.yMax() <= 0.0 || gfscale.yMin() <= 0.0)
	{
		xlogscale_checkbox->setEnabled(FALSE);
	}
	else
	{
		ylogscale_checkbox->setEnabled(TRUE);
	}
	
	switch(gfscale.ticksType())
	{
		default:
		case TT_NONE:
			noticks_radiobutton->setChecked(TRUE);
		break;
		case TT_TICKS:
			ticks_radiobutton->setChecked(TRUE);
		break;
		case TT_GRIDS:
			grids_radiobutton->setChecked(TRUE);
		break;				
	}
	
	if(gfscale.xLabelLen() > 0)
	{
		strmalloc(&label,gfscale.xLabelLen());
		gfscale.xLabel(label);
		xlabel_lineedit->setText(label);
		free(label);
	}
	
	if(gfscale.yLabelLen() > 0)
	{
		strmalloc(&label,gfscale.yLabelLen());
		gfscale.yLabel(label);
		ylabel_lineedit->setText(label);
		free(label);
	}
	
}

void GfScaleWin::setVisibles(const char *)
{

	setVisibles();
}

void GfScaleWin::setVisibles()
{
float xmax,xmin,ymax,ymin;

	xmax = atof(xmax_lineedit->text());
	xmin = atof(xmin_lineedit->text());
	
	if( xmax <= 0.0 || xmin <= 0.0 )
	{
		xlogscale_checkbox->setEnabled(FALSE);
	}
	else
	{
		xlogscale_checkbox->setEnabled(TRUE);
	}
	
	ymax = atof(ymax_lineedit->text());
	ymin = atof(ymin_lineedit->text());
	
	if( ymax <= 0.0 || ymin <= 0.0 )
	{
		ylogscale_checkbox->setEnabled(FALSE);
	}
	else
	{
		ylogscale_checkbox->setEnabled(TRUE);
	}
	

	if( noticks_radiobutton->isChecked() == TRUE)
	{
		xstep_lineedit->setEnabled(FALSE);
		ystep_lineedit->setEnabled(FALSE);
		xstep_label->setEnabled(FALSE);
		ystep_label->setEnabled(FALSE);
	}
	else
	{
		xstep_lineedit->setEnabled(TRUE);
		ystep_lineedit->setEnabled(TRUE);
		xstep_label->setEnabled(TRUE);
		ystep_label->setEnabled(TRUE);
	}
	
#ifdef DEBUG1
	cout <<"setting visibles\n";
#endif	

}

void GfScaleWin::getValues()
{
float xmax,xmin,ymax,ymin,xstep,ystep;

	xmax = atof(xmax_lineedit->text());
	xmin = atof(xmin_lineedit->text());
	
	ymax = atof(ymax_lineedit->text());
	ymin = atof(ymin_lineedit->text());
	
	gfscale.setXMaxMin(xmax,xmin);

	gfscale.setYMaxMin(ymax,ymin);
	
	if(xlogscale_checkbox->isChecked() == TRUE)
	{
		gfscale.setXLogScale(GF_YES);
	}
	else
	{
		gfscale.setXLogScale(GF_NO);
	}
	
	if(ylogscale_checkbox->isChecked() == TRUE)
	{
		gfscale.setYLogScale(GF_YES);
	}
	else
	{
		gfscale.setYLogScale(GF_NO);
	}
	
	gfscale.setXLabel(xlabel_lineedit->text());
	gfscale.setYLabel(ylabel_lineedit->text());
	
	if(noticks_radiobutton->isChecked() == FALSE)
	{
		xstep = atof(xstep_lineedit->text());
		gfscale.setXTicksStep(xstep);
		ystep = atof(ystep_lineedit->text());
		gfscale.setYTicksStep(ystep);
	
		if(ticks_radiobutton->isChecked() == TRUE)
		{
			gfscale.setTicksType(TT_TICKS);
		}
		if(grids_radiobutton->isChecked() == TRUE)
		{
			gfscale.setTicksType(TT_GRIDS);
		}		
	}
	else
	{
		gfscale.setTicksType(TT_NONE);
	}

}

void GfScaleWin::applyButton()
{
	getValues();
	
	gffile->setScale(gfscale);
	
	emit scaleChanged();
}

void GfScaleWin::autoButton()
{
	gffile->autoScale();
	
	gfscale = gffile->scale();
	
	setValues();
	
	setVisibles();
	
	emit scaleChanged();

}

void GfScaleWin::dismissButton()
{
	done(0);
}


